<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
   
   <meta name="description" content="FLUBIO - An unstructured, parallel, finite volume Navier-Stokes solver for teaching and research purposes">
    
    <meta name="author" content="Edoardo Alinovi and Joel Guerrero" >
    <link rel="icon" href="../favicon.png">

    <title>notabs &ndash; FLUBIO</title>

    <link href="../css/bootstrap.min.css" rel="stylesheet">
    <link href="../css/pygments.css" rel="stylesheet">
    <link href="../css/font-awesome.min.css" rel="stylesheet">
    <link href="../css/local.css" rel="stylesheet">
    
    <link  href="../tipuesearch/tipuesearch.css" rel="stylesheet">
    
    

    <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
    <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
    
    <script src="../js/jquery-2.1.3.min.js"></script>
    <script src="../js/svg-pan-zoom.min.js"></script>

  </head>

  <body>

    <!-- Fixed navbar -->
    <nav class="navbar navbar-inverse navbar-fixed-top">
      <div class="container">
        <div class="navbar-header">
          <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar">
            <span class="sr-only">Toggle navigation</span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
          <a class="navbar-brand" href="../index.html">FLUBIO </a>
        </div>
        <div id="navbar" class="navbar-collapse collapse">
          <ul class="nav navbar-nav">
        
            <li class="dropdown hidden-xs visible-sm visible-md hidden-lg">
              <a href="#" class="dropdown-toggle"
              data-toggle="dropdown" role="button"
              aria-haspopup="true"
     aria-expanded="false">Contents <span class="caret"></span></a>
        <ul class="dropdown-menu">
          
              
            <li><a href="../lists/files.html">Source Files</a></li>
        
        
        
            <li><a href="../lists/modules.html">Modules</a></li>
        
            
                                
            <li><a href="../lists/procedures.html">Procedures</a></li>
        
               
            <li><a href="../lists/types.html">Derived Types</a></li>
        
        
            <li><a href="../lists/programs.html">Programs</a></li>
               
        
        
            </ul>
        
            </li>


<li class="visible-xs hidden-sm visible-lg"><a href="../lists/files.html">Source Files</a></li>



<li class="visible-xs hidden-sm visible-lg"><a href="../lists/modules.html">Modules</a></li>



<li class="visible-xs hidden-sm visible-lg"><a href="../lists/procedures.html">Procedures</a></li>

                             
<li class="visible-xs hidden-sm visible-lg"><a href="../lists/types.html">Derived Types</a></li>


<li class="visible-xs hidden-sm visible-lg"><a href="../lists/programs.html">Programs</a></li>



          </ul>
        
        <form action="../search.html" class="navbar-form navbar-right" role="search">
        <div class="form-group">
          <input type="text" class="form-control" placeholder="Search" name="q" id="tipue_search_input" autocomplete="off" required>
        </div>
<!--
        <button type="submit" class="btn btn-default">Submit</button>
-->
        </form>
        
        </div><!--/.nav-collapse -->
      </div>
    </nav>

    <div class="container">
    
  
  <div class="row">
    <h1>notabs
      <small>Subroutine</small>
    
    </h1>
    
<div class="row">
  <div class="col-lg-12">
<div class="well well-sm">
  <ul class="list-inline" style="margin-bottom:0px;display:inline">
     
     
     
    <li><i class="fa fa-legal"></i> <a rel="license" href="http://creativecommons.org/licenses/by-nc/4.0/"><img alt="Creative Commons License" style="border-width:0" src="https://i.creativecommons.org/l/by-nc/4.0/80x15.png" /></a></li> 
     
     
     
    
    
     <li><i class="fa fa-list-ol"></i>
       <a data-toggle="tooltip"
    data-placement="bottom" data-html="true"
    title=" 0.2% of total for procedures.">38 statements</a>
     </li> 
     
     
     
    <li><i class="fa fa-code"></i><a href="../src/mstrings.f03"> Source File</a></li>
     
     
  </ul>
  <ol class="breadcrumb in-well text-right">
  
    
     <li><a href='../sourcefile/mstrings.f03.html'>mstrings.f03</a></li>
    
     <li><a href='../module/m_strings.html'>M_strings</a></li>
    
  
     <li class="active">notabs</li>
  </ol>
</div>
</div>
</div>
<script>
  $(function () {
  $('[data-toggle="tooltip"]').tooltip()
  })
</script>

  </div>
  
  <div class="row">
    <div class="col-md-3 hidden-xs hidden-sm visible-md visible-lg">
    
<div id="sidebar">
  
<h3>Contents</h3>
 





















<em>None</em>


</div>

    </div>
    
    <div class="col-md-9" id='text'>
    <h2>
public subroutine notabs(instr, outstr, ilen)
    
    
   
</h2>
    
  


    
    <h2>NAME</h2>
<div class="codehilite"><pre><span></span><code>notabs(3f) - [M_strings:NONALPHA] expand tab characters
</code></pre></div>

<h2>SYNOPSIS</h2>
<div class="codehilite"><pre><span></span><code>subroutine notabs(INSTR,OUTSTR,ILEN)

 character(len=*),intent=(in)  :: INSTR
 character(len=*),intent=(out) :: OUTSTR
 integer,intent=(out)          :: ILEN
</code></pre></div>

<h2>DESCRIPTION</h2>
<div class="codehilite"><pre><span></span><code> <span class="nt">NOTABS</span><span class="o">()</span> <span class="nt">converts</span> <span class="nt">tabs</span> <span class="nt">in</span> <span class="nt">INSTR</span> <span class="nt">to</span> <span class="nt">spaces</span> <span class="nt">in</span> <span class="nt">OUTSTR</span> <span class="nt">while</span> <span class="nt">maintaining</span>
 <span class="nt">columns</span><span class="o">.</span> <span class="nt">It</span> <span class="nt">assumes</span> <span class="nt">a</span> <span class="nt">tab</span> <span class="nt">is</span> <span class="nt">set</span> <span class="nt">every</span> <span class="nt">8</span> <span class="nt">characters</span><span class="o">.</span>  <span class="nt">Trailing</span> <span class="nt">spaces</span><span class="o">,</span>
 <span class="nt">carriage</span> <span class="nt">returns</span><span class="o">,</span> <span class="nt">and</span> <span class="nt">line</span> <span class="nt">feeds</span> <span class="nt">are</span> <span class="nt">removed</span><span class="o">.</span>

 <span class="nt">It</span> <span class="nt">is</span> <span class="nt">often</span> <span class="nt">useful</span> <span class="nt">to</span> <span class="nt">expand</span> <span class="nt">tabs</span> <span class="nt">in</span> <span class="nt">input</span> <span class="nt">files</span> <span class="nt">to</span> <span class="nt">simplify</span> <span class="nt">further</span>
 <span class="nt">processing</span> <span class="nt">such</span> <span class="nt">as</span> <span class="nt">tokenizing</span> <span class="nt">an</span> <span class="nt">input</span> <span class="nt">line</span><span class="o">.</span>

 <span class="nt">Also</span><span class="o">,</span> <span class="nt">trailing</span> <span class="nt">carriage</span> <span class="nt">returns</span> <span class="nt">and</span> <span class="nt">line</span> <span class="nt">feed</span> <span class="nt">characters</span> <span class="nt">are</span> <span class="nt">removed</span><span class="o">,</span>
 <span class="nt">as</span> <span class="nt">they</span> <span class="nt">are</span> <span class="nt">usually</span> <span class="nt">a</span> <span class="nt">problem</span> <span class="nt">created</span> <span class="nt">by</span> <span class="nt">going</span> <span class="nt">to</span> <span class="nt">and</span> <span class="nt">from</span> <span class="nt">MSWindows</span><span class="o">.</span>

 <span class="nt">Sometimes</span> <span class="nt">tabs</span> <span class="nt">in</span> <span class="nt">files</span> <span class="nt">cause</span> <span class="nt">problems</span><span class="o">.</span> <span class="nt">For</span> <span class="nt">example</span><span class="o">:</span> <span class="nt">Some</span> <span class="nt">FORTRAN</span>
 <span class="nt">compilers</span> <span class="nt">hate</span> <span class="nt">tabs</span><span class="o">;</span> <span class="nt">some</span> <span class="nt">printers</span><span class="o">;</span> <span class="nt">some</span> <span class="nt">editors</span> <span class="nt">will</span> <span class="nt">have</span> <span class="nt">problems</span>
 <span class="nt">with</span> <span class="nt">tabs</span><span class="o">.</span>
</code></pre></div>

<h2>OPTIONS</h2>
<div class="codehilite"><pre><span></span><code> instr     Input line to remove tabs from
</code></pre></div>

<h2>RESULTS</h2>
<div class="codehilite"><pre><span></span><code> outstr    Output string with tabs expanded.
 ilen      Significant length of returned string
</code></pre></div>

<h2>EXAMPLES</h2>
<p>Sample program:</p>
<div class="codehilite"><pre><span></span><code><span class="nv">program</span> <span class="nv">demo_notabs</span>

<span class="o">!</span>  <span class="nv">test</span> <span class="nv">filter</span> <span class="nv">to</span> <span class="nv">remove</span> <span class="nv">tabs</span> <span class="nv">and</span> <span class="nv">trailing</span> <span class="nv">white</span> <span class="nv">space</span> <span class="nv">from</span> <span class="nv">input</span>
<span class="o">!</span>  <span class="nv">on</span> <span class="nv">files</span> <span class="nv">up</span> <span class="nv">to</span> <span class="mi">1024</span> <span class="nv">characters</span> <span class="nv">wide</span>
<span class="nv">use</span> <span class="nv">M_strings</span>, <span class="nv">only</span> : <span class="nv">notabs</span>
<span class="nv">character</span><span class="ss">(</span><span class="nv">len</span><span class="o">=</span><span class="mi">1024</span><span class="ss">)</span> :: <span class="nv">in</span>,<span class="nv">out</span>
<span class="nv">integer</span>             :: <span class="nv">ios</span>,<span class="nv">iout</span>
   <span class="nv">READFILE</span>: <span class="nv">block</span>
      <span class="k">do</span>
         <span class="nv">read</span><span class="ss">(</span><span class="o">*</span>,<span class="s1">&#39;</span><span class="s">(A)</span><span class="s1">&#39;</span>,<span class="nv">iostat</span><span class="o">=</span><span class="nv">ios</span><span class="ss">)</span><span class="nv">in</span>
         <span class="k">if</span><span class="ss">(</span><span class="nv">ios</span> <span class="o">/=</span> <span class="mi">0</span><span class="ss">)</span> <span class="k">exit</span> <span class="nv">READFILE</span>
         <span class="k">call</span> <span class="nl">notabs</span><span class="ss">(</span><span class="nv">in</span>,<span class="nv">out</span>,<span class="nv">iout</span><span class="ss">)</span>
         <span class="nv">write</span><span class="ss">(</span><span class="o">*</span>,<span class="s1">&#39;</span><span class="s">(a)</span><span class="s1">&#39;</span><span class="ss">)</span><span class="nv">out</span><span class="ss">(</span>:<span class="nv">iout</span><span class="ss">)</span>
      <span class="nv">enddo</span>
   <span class="nv">endblock</span> <span class="nv">READFILE</span>

<span class="k">end</span> <span class="nv">program</span> <span class="nv">demo_notabs</span>
</code></pre></div>

<h2>AUTHOR:</h2>
<div class="codehilite"><pre><span></span><code> John S. Urban
</code></pre></div>

<h2>SEE ALSO:</h2>
<div class="codehilite"><pre><span></span><code> GNU/Unix commands expand(1) and unexpand(1)
</code></pre></div>
    

    <h3>Arguments</h3>
    
      
<table class="table table-striped varlist">
<thead><tr><th>Type</th>
<th>Intent</th><th>Optional</th>
<th>Attributes</th><th></th><th>Name</th><th></th></thead>



<tbody>

  
  
  
  
<tr>
  
  <td><span class="anchor" id="variable-instr%7E2"></span>character(len=*),</td>
  <td>intent(in)</td>
  <td></td>
  
  <td></td><td>::</td>
  <td><strong>instr</strong></td><td></td>
  
</tr>

  
  
  
  
<tr>
  
  <td><span class="anchor" id="variable-outstr%7E8"></span>character(len=*),</td>
  <td>intent(out)</td>
  <td></td>
  
  <td></td><td>::</td>
  <td><strong>outstr</strong></td><td></td>
  
</tr>

  
  
  
  
<tr>
  
  <td><span class="anchor" id="variable-ilen%7E2"></span>integer,</td>
  <td>intent(out)</td>
  <td></td>
  
  <td></td><td>::</td>
  <td><strong>ilen</strong></td><td></td>
  
</tr>

</tbody>
</table>

    
    
    
    
     
    <br>

    <section class="visible-xs visible-sm hidden-md">
      
<h3>Contents</h3>
 





















<em>None</em>


    </section>
    <br class="visible-xs visible-sm hidden-md">

    

    
    
    
    
    

    
    
    
    
    


    
    
    
    
    </div>
  </div>


    <hr>    
    </div> <!-- /container -->
    <footer>
      <div class="container">
      <div class="row">
        <div class="col-xs-6 col-md-6"><p>FLUBIO was developed by Edoardo Alinovi and Joel Guerrero<br>&copy; 2021 <a rel="license" href="http://creativecommons.org/licenses/by-nc/4.0/"><img alt="Creative Commons License" style="border-width:0" src="https://i.creativecommons.org/l/by-nc/4.0/80x15.png" /></a>
                                          </p>
        </div>
        <div class="col-xs-6 col-md-6">
          <p class="text-right">
            Documentation generated by 
            <a href="https://github.com/Fortran-FOSS-Programmers/ford">FORD</a>
            
            
          </p>
        </div>
      </div>
      <br>
      </div> <!-- /container -->    
    </footer>

    <!-- Bootstrap core JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
<!--
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
-->
    <script src="../js/bootstrap.min.js"></script>
    <!-- IE10 viewport hack for Surface/desktop Windows 8 bug -->
    <script src="../js/ie10-viewport-bug-workaround.js"></script>

    <!-- MathJax JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
    <script type="text/x-mathjax-config">
      MathJax.Hub.Config({
        TeX: { extensions: ['AMSmath.js','AMSsymbols.js','noErrors.js','noUndefined.js'], equationNumbers: { autoNumber: 'AMS' } },
        jax: ['input/TeX','input/MathML','output/HTML-CSS'],
        extensions: ['tex2jax.js','mml2jax.js','MathMenu.js','MathZoom.js']
      });
    </script>
    
    <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
    
    
    <script src="../tipuesearch/tipuesearch_content.js"></script>
    <script src="../tipuesearch/tipuesearch_set.js"></script>
    <script src="../tipuesearch/tipuesearch.js"></script>
    
    
  </body>
</html>